'use strict';

var B = require('fast-deep-equal/es6/react');
var zod = require('zod');
var builtIn = require('@terminal-nerds/snippets-type/built-in');
var H = require('array-differ');
var snippetsNumber = require('@terminal-nerds/snippets-number');
var random = require('@terminal-nerds/snippets-number/random');
var L = require('array-union');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var B__default = /*#__PURE__*/_interopDefault(B);
var H__default = /*#__PURE__*/_interopDefault(H);
var L__default = /*#__PURE__*/_interopDefault(L);

var D=["signed","unsigned"],E=builtIn.BUILT_IN_OBJECTS_SCHEMAS.BigInt64Array,C=builtIn.BUILT_IN_OBJECTS_SCHEMAS.BigUint64Array,T={signed:E,unsigned:C};function q(e,r){let{type:t}=r;T[t].parse(e);}function J(e,r){let{type:t}=r;return T[t].safeParse(e).success}var x=d.length(0);function Q(e){x.parse(e);}function c(e){return y(e),x.safeParse(e).success}var $=[32,64],S=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Float32Array,V=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Float64Array,m={32:S,64:V};function ee(e,r){let{bit:t}=r;m[t].parse(e);}function re(e,r){let{bit:t}=r;return m[t].safeParse(e).success}var oe=["signed","unsigned"],ye=[8,16,32],se=["clamped","standard"],Y=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Int8Array,O=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Int16Array,w=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Int32Array,U={8:{standard:Y},16:{standard:O},32:{standard:w}},N=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Uint8Array,F=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Uint8ClampedArray,M=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Uint16Array,b=builtIn.BUILT_IN_OBJECTS_SCHEMAS.Uint32Array,v={8:{standard:N,clamped:F},16:{standard:M},32:{standard:b}},A={signed:U,unsigned:v};function g(e){return e==="unsigned"}function f(e){return e===8}function pe(e,r){let{type:t,bit:n}=r;if(g(t)&&f(n)){let{clamped:p=!1}=r;A[t][n][p?"clamped":"standard"].parse(e);}else A[t][n].standard.parse(e);}function Ae(e,r){let{type:t,bit:n}=r;if(g(t)&&f(n)){let{clamped:p=!1}=r;return A[t][n][p?"clamped":"standard"].safeParse(e).success}else return A[t][n].standard.safeParse(e).success}var d=zod.z.array(zod.z.any());function y(e){d.parse(e);}function o(...e){for(let r of e)y(r);}function Re(e,r){return o(e,r),e.length===r.length?B__default.default(e,r):!1}function Be(e,r){return o(e,r),e.length===r.length?B__default.default(e.sort(),r.sort()):!1}function Ve(e,...r){return o(e,...r),H__default.default(e,...r)}function Ye(e,r){o(e,r);let t=new Set(e),n=new Set(r),p=e.filter(i=>!n.has(i)),_=r.filter(i=>!t.has(i));return [...p,..._]}function Ne(e,r){return o(e,r),e.filter(t=>!r.includes(t))}function Fe(e,r){return o(e,r),e.filter(t=>r.includes(t))}function He(e,r){o(e,r);let t=new Set(e);return [...new Set(r.filter(n=>t.has(n)))]}async function u(e){return await random.getRandomIntNumber({min:0,max:e-1})}async function G(e){return y(e),e.at(await u(e.length))}async function De(e,r){let{count:t}=r;snippetsNumber.validatePositiveInteger(t);let n=[];for(;n.length<t;)n.push(await G(e));return n}async function Qe(e){if(y(e),c(e))return [];{let r=[...e];for(let t=e.length-1;t>0;t--){let n=await u(e.length);[r[t],r[n]]=[r[n],r[t]];}return r}}function er(...e){return o(...e),L__default.default(...e)}function ar(e){return y(e),[...new Set(e)]}

exports.ARRAY_SCHEMA = d;
exports.BIGINT64_ARRAY_SCHEMA = E;
exports.BIGINT_ARRAY_SCHEMAS = T;
exports.BIGINT_ARRAY_TYPES = D;
exports.BIGUINT64_ARRAY_SCHEMA = C;
exports.EMPTY_ARRAY_SCHEMA = x;
exports.FLOAT32_ARRAY_SCHEMA = S;
exports.FLOAT64_ARRAY_SCHEMA = V;
exports.FLOAT_ARRAY_BITS = $;
exports.FLOAT_ARRAY_SCHEMAS = m;
exports.INT16_ARRAY_SCHEMA = O;
exports.INT32_ARRAY_SCHEMA = w;
exports.INT8_ARRAY_SCHEMA = Y;
exports.INTEGER_ARRAY_BITS = ye;
exports.INTEGER_ARRAY_CATEGORIES = se;
exports.INTEGER_ARRAY_SCHEMAS = A;
exports.INTEGER_ARRAY_TYPES = oe;
exports.INT_ARRAY_SCHEMAS = U;
exports.UINT16_ARRAY_SCHEMA = M;
exports.UINT32_ARRAY_SCHEMA = b;
exports.UINT8_ARRAY_SCHEMA = N;
exports.UINT8_CLAMPED_ARRAY_SCHEMA = F;
exports.UINT_ARRAY_SCHEMAS = v;
exports.areArraysEqual = Re;
exports.areArraysItemsSame = Be;
exports.exclude = Ne;
exports.extract = Fe;
exports.getArrayDifference = Ve;
exports.getArrayUniques = ar;
exports.getArraysIntersection = He;
exports.getArraysSymmetricDifference = Ye;
exports.getArraysUnion = er;
exports.getRandomIndex = u;
exports.getRandomItem = G;
exports.getRandomItems = De;
exports.is8Bit = f;
exports.isBigIntArray = J;
exports.isEmptyArray = c;
exports.isFloatArray = re;
exports.isIntegerArray = Ae;
exports.isUnsigned = g;
exports.shuffleArray = Qe;
exports.validateArray = y;
exports.validateArrays = o;
exports.validateBigIntArray = q;
exports.validateEmptyArray = Q;
exports.validateFloatArray = ee;
exports.validateIntegerArray = pe;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=main.cjs.map